# Kiln OmniVaults Direct FAQ

## Reward Fee Logic

### How often do rewards accrue to the vault?

It depends on the mechanics of the underlying DeFi protocol, but Kiln DeFi vaults continuously update to reflect the corresponding changes to the total value held by the vault and the corresponding exchange rate of the vault share tokens.

### How are vault rewards calculated?

The reward calculation is based on the growth of the vault TVL ("Total Value Locked") since the last snapshot, which happens automatically during any deposit, withdraw, mint, or redeem vault interaction.

The fee on rewards earned by integrators is implementing by minting additional vault shares that inflate the total number of shares proportionally. This means that the fees collected continue to earn yield until they are withdrawn from the vault by the integrator.

### Are partial withdrawals from the vault allowed?

Yes.

### How are vault rewards denominated in tokens other than the asset deposited in the vault handled?

There are three options available for dealing with this situation. As an example, let's say that a vault with USDC as the deposit asset is eligible to claim COMP tokens. The integrator can choose to:

1. Leave the COMP tokens unclaimed
2. Claim the COMP tokens for themselves and do not distribute them to end users of the vault
3. Claim the COMP tokens, use a function provided by Kiln to swap the COMP tokens for USDC on a decentralized exchange and deposit the proceeds into the vault

Unique situations that cannot be covered with one of the three approaches above will be handled on a bespoke basis between Kiln and the integrator.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.kiln.fi/v1/kiln-products/omnivaults/kiln-omnivaults-direct-faq.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
